<?php



/*
 * LinkPoint functions
 */

	function linkpoint_order_xml($pdata)
	{
		// ORDEROPTIONS NODE
		$xml = "<order><orderoptions>";
		if (isset($pdata["ordertype"]))
			$xml .= "<ordertype>" . $pdata["ordertype"] . "</ordertype>";
		if (isset($pdata["result"]))
			$xml .= "<result>" . $pdata["result"] . "</result>";
		$xml .= "</orderoptions>";


		// CREDITCARD NODE
		$xml .= "<creditcard>";
		if (isset($pdata["cardnumber"]))
			$xml .= "<cardnumber>" . $pdata["cardnumber"] . "</cardnumber>";
		if (isset($pdata["cardexpmonth"]))
			$xml .= "<cardexpmonth>" . $pdata["cardexpmonth"] . "</cardexpmonth>";
		if (isset($pdata["cardexpyear"]))
			$xml .= "<cardexpyear>" . $pdata["cardexpyear"] . "</cardexpyear>";
		if (isset($pdata["cvmvalue"]))
			$xml .= "<cvmvalue>" . $pdata["cvmvalue"] . "</cvmvalue>";
		if (isset($pdata["cvmindicator"]))
			$xml .= "<cvmindicator>" . $pdata["cvmindicator"] . "</cvmindicator>";
		if (isset($pdata["track"]))
			$xml .= "<track>" . $pdata["track"] . "</track>";
		$xml .= "</creditcard>";


		// BILLING NODE
		$xml .= "<billing>";
		if (isset($pdata["name"]))
			$xml .= "<name>" . xml_escape_string($pdata["name"]) . "</name>";
		if (isset($pdata["company"]))
			$xml .= "<company>" . xml_escape_string($pdata["company"]) . "</company>";
		if (isset($pdata["address1"]))
			$xml .= "<address1>" . xml_escape_string($pdata["address1"]) . "</address1>";
		elseif (isset($pdata["address"]))
			$xml .= "<address1>" . xml_escape_string($pdata["address"]) . "</address1>";
		if (isset($pdata["address2"]))
			$xml .= "<address2>" . xml_escape_string($pdata["address2"]) . "</address2>";
		if (isset($pdata["city"]))
			$xml .= "<city>" . xml_escape_string($pdata["city"]) . "</city>";
		if (isset($pdata["state"]))
			$xml .= "<state>" . xml_escape_string($pdata["state"]) . "</state>";
		if (isset($pdata["zip"]))
			$xml .= "<zip>" . $pdata["zip"] . "</zip>";
		if (isset($pdata["country"]))
			$xml .= "<country>" . xml_escape_string($pdata["country"]) . "</country>";
		if (isset($pdata["userid"]))
			$xml .= "<userid>" . $pdata["userid"] . "</userid>";
		if (isset($pdata["email"]))
			$xml .= "<email>" . $pdata["email"] . "</email>";
		if (isset($pdata["phone"]))
			$xml .= "<phone>" . $pdata["phone"] . "</phone>";
		if (isset($pdata["fax"]))
			$xml .= "<fax>" . $pdata["fax"] . "</fax>";
		if (isset($pdata["addrnum"]))
			$xml .= "<addrnum>" . $pdata["addrnum"] . "</addrnum>";
		$xml .= "</billing>";


		// SHIPPING NODE
		$xml .= "<shipping>";
		if (isset($pdata["sname"]))
			$xml .= "<name>" . xml_escape_string($pdata["sname"]) . "</name>";
		if (isset($pdata["saddress1"]))
			$xml .= "<address1>" . xml_escape_string($pdata["saddress1"]) . "</address1>";
		if (isset($pdata["saddress2"]))
			$xml .= "<address2>" . xml_escape_string($pdata["saddress2"]) . "</address2>";
		if (isset($pdata["scity"]))
			$xml .= "<city>" . xml_escape_string($pdata["scity"]) . "</city>";
		if (isset($pdata["sstate"]))
			$xml .= "<state>" . xml_escape_string($pdata["sstate"]) . "</state>";
		if (isset($pdata["szip"]))
			$xml .= "<zip>" . $pdata["szip"] . "</zip>";
		if (isset($pdata["scountry"]))
			$xml .= "<country>" . xml_escape_string($pdata["scountry"]) . "</country>";
		if (isset($pdata["scarrier"]))
			$xml .= "<carrier>" . $pdata["scarrier"] . "</carrier>";
		if (isset($pdata["sitems"]))
			$xml .= "<items>" . $pdata["sitems"] . "</items>";
		if (isset($pdata["sweight"]))
			$xml .= "<weight>" . $pdata["sweight"] . "</weight>";
		if (isset($pdata["stotal"]))
			$xml .= "<total>" . $pdata["stotal"] . "</total>";
		$xml .= "</shipping>";


		// TRANSACTIONDETAILS NODE
		$xml .= "<transactiondetails>";
		if (isset($pdata["oid"]))
			$xml .= "<oid>" . $pdata["oid"] . "</oid>";
		if (isset($pdata["ponumber"]))
			$xml .= "<ponumber>" . $pdata["ponumber"] . "</ponumber>";
		if (isset($pdata["recurring"]))
			$xml .= "<recurring>" . $pdata["recurring"] . "</recurring>";
		if (isset($pdata["taxexempt"]))
			$xml .= "<taxexempt>" . $pdata["taxexempt"] . "</taxexempt>";
		if (isset($pdata["terminaltype"]))
			$xml .= "<terminaltype>" . $pdata["terminaltype"] . "</terminaltype>";
		if (isset($pdata["ip"]))
			$xml .= "<ip>" . $pdata["ip"] . "</ip>";
		if (isset($pdata["reference_number"]))
			$xml .= "<reference_number>" . $pdata["reference_number"] . "</reference_number>";
		if (isset($pdata["transactionorigin"]))
			$xml .= "<transactionorigin>" . $pdata["transactionorigin"] . "</transactionorigin>";
		if (isset($pdata["tdate"]))
			$xml .= "<tdate>" . $pdata["tdate"] . "</tdate>";
		$xml .= "</transactiondetails>";


		// MERCHANTINFO NODE
		$xml .= "<merchantinfo>";
		if (isset($pdata["configfile"]))
			$xml .= "<configfile>" . $pdata["configfile"] . "</configfile>";
		if (isset($pdata["keyfile"]))
			$xml .= "<keyfile>" . $pdata["keyfile"] . "</keyfile>";
		if (isset($pdata["host"]))
			$xml .= "<host>" . $pdata["host"] . "</host>";
		if (isset($pdata["port"]))
			$xml .= "<port>" . $pdata["port"] . "</port>";
		if (isset($pdata["appname"]))
			$xml .= "<appname>" . xml_escape_string($pdata["appname"]) . "</appname>";
		$xml .= "</merchantinfo>";


		// PAYMENT NODE
		$xml .= "<payment>";
		if (isset($pdata["chargetotal"]))
			$xml .= "<chargetotal>" . $pdata["chargetotal"] . "</chargetotal>";
		if (isset($pdata["tax"]))
			$xml .= "<tax>" . $pdata["tax"] . "</tax>";
		if (isset($pdata["vattax"]))
			$xml .= "<vattax>" . $pdata["vattax"] . "</vattax>";
		if (isset($pdata["shipping"]))
			$xml .= "<shipping>" . $pdata["shipping"] . "</shipping>";
		if (isset($pdata["subtotal"]))
			$xml .= "<subtotal>" . $pdata["subtotal"] . "</subtotal>";
		$xml .= "</payment>";


		// CHECK NODE
		if (isset($pdata["voidcheck"]))
		{
			$xml .= "<telecheck><void>1</void></telecheck>";
		}
		elseif (isset($pdata["routing"]))
		{
			$xml .= "<telecheck>";
			$xml .= "<routing>" . $pdata["routing"] . "</routing>";
			if (isset($pdata["account"]))
				$xml .= "<account>" . $pdata["account"] . "</account>";
			if (isset($pdata["bankname"]))
				$xml .= "<bankname>" . xml_escape_string($pdata["bankname"]) . "</bankname>";
			if (isset($pdata["bankstate"]))
				$xml .= "<bankstate>" . xml_escape_string($pdata["bankstate"]) . "</bankstate>";
			if (isset($pdata["ssn"]))
				$xml .= "<ssn>" . $pdata["ssn"] . "</ssn>";
			if (isset($pdata["dl"]))
				$xml .= "<dl>" . $pdata["dl"] . "</dl>";
			if (isset($pdata["dlstate"]))
				$xml .= "<dlstate>" . xml_escape_string($pdata["dlstate"]) . "</dlstate>";
			if (isset($pdata["checknumber"]))
				$xml .= "<checknumber>" . $pdata["checknumber"] . "</checknumber>";
			if (isset($pdata["accounttype"]))
				$xml .= "<accounttype>" . $pdata["accounttype"] . "</accounttype>";
			$xml .= "</telecheck>";
		}

		// PERIODIC NODE
		if (isset($pdata["startdate"]))
		{
			$xml .= "<periodic>";
			$xml .= "<startdate>" . $pdata["startdate"] . "</startdate>";
			if (isset($pdata["installments"]))
				$xml .= "<installments>" . $pdata["installments"] . "</installments>";
			if (isset($pdata["threshold"]))
						$xml .= "<threshold>" . $pdata["threshold"] . "</threshold>";
			if (isset($pdata["periodicity"]))
						$xml .= "<periodicity>" . $pdata["periodicity"] . "</periodicity>";
			if (isset($pdata["pbcomments"]))
						$xml .= "<comments>" . $pdata["pbcomments"] . "</comments>";
			if (isset($pdata["action"]))
				$xml .= "<action>" . $pdata["action"] . "</action>";
			$xml .= "</periodic>";
		}

		// NOTES NODE
		if (isset($pdata["comments"]) || isset($pdata["referred"]))
		{
			$xml .= "<notes>";
			if (isset($pdata["comments"]))
				$xml .= "<comments>" . xml_escape_string($pdata["comments"]) . "</comments>";
			if (isset($pdata["referred"]))
				$xml .= "<referred>" . xml_escape_string($pdata["referred"]) . "</referred>";
			$xml .= "</notes>";
		}

		// ITEMS AND OPTIONS NODES
		while (list ($key, $val) = each ($pdata))
		{
			if (is_array($val))
			{
				$otag = 0;
				$ostag = 0;
				$items_array = $val;
				$xml .= "<items>";

				while(list($key1, $val1) = each ($items_array))
				{
					$xml .= "<item>";

					while (list($key2, $val2) = each ($val1))
					{
						if (!is_array($val2)) {
							$xml .= "<$key2>" . xml_escape_string($val2) . "</$key2>";
						} else {
							if (!$ostag) {
								$xml .= "<options>";
								$ostag = 1;
							}

							$xml .= "<option>";
							$otag = 1;

							while (list($key3, $val3) = each ($val2)) {
								$xml .= "<$key3>" . xml_escape_string($val3) . "</$key3>";
							}
						}
						if ($otag) {
							$xml .= "</option>";
							$otag = 0;
						}
					}
					if ($ostag) {
						$xml .= "</options>";
						$ostag = 0;
					}
				$xml .= "</item>";
				}
			$xml .= "</items>";
			}
		}
		$xml .= "</order>";

		return $xml;
	}

?>