<?php

	$xml = ups_prepare_rate_request($module_params);
	$response = '';
	if (strlen($xml)) {
		$ch = curl_init ();
		curl_setopt($ch, CURLOPT_URL, $external_url);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		set_curl_options($ch, $module_params);

		$response = curl_exec($ch);
		curl_close($ch);
	} else {
		return;
	}
	$response = trim($response);
	if (strlen($response)) {
		$response_parameters = array();
		preg_match_all("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $response, $matches, PREG_SET_ORDER);
		for($i = 0; $i < sizeof($matches); $i++) {
			$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
		}
		if (isset($response_parameters["ErrorCode"])) {
			if (strtoupper($response_parameters["ErrorSeverity"]) != 'WARNING'){
				$r->errors .= sprintf("UPS. Error occured: %s - %s <br>", $response_parameters["ErrorCode"], $response_parameters["ErrorDescription"]);
			}
		}
		$rated_shipment=array();
		preg_match_all("/<RatedShipment>(.*)\<\/RatedShipment>/Uis", $response, $rated_raw, PREG_SET_ORDER);
		for($i = 0; $i < sizeof($rated_raw); $i++) {
			preg_match("/<Service>\s*<Code>(.*)<\/Code>\s*<\/Service>.*<TotalCharges>.*<CurrencyCode>(.*)<\/CurrencyCode>.*<MonetaryValue>(.*)\<\/MonetaryValue>.*<\/TotalCharges>.*<RatedPackage>(.*)<\/RatedPackage>/Uis", $rated_raw[$i][1], $total_raw);
			$service_code = $total_raw[1];
			$monetary_value = $total_raw[3];
			$rated_shipment[] = array($service_code,$monetary_value);
		}
		foreach ($module_shipping as $module) {
			foreach ($rated_shipment as $rated) {
				if ($module[1] == $rated[0]) {
					$module[3] += $rated[1];
					$shipping_types[] = $module;
				}
			}
		}
	}
	else {
		$r->errors .= "UPS server doesn't answer.<br>\r\n";
	}

	function ups_prepare_rate_request($module_params)
	{
		global $r, $shipping_weight, $state_code, $country_code, $postal_code;
		$xml = '';
		if (!strlen($country_code) || !strlen($postal_code)) {
			return $xml;
		}

		$xml  = '<?xml version="1.0"?>';
		$xml .= '<AccessRequest xml:lang="en-US">';
		if (isset($module_params["access_license_number"])) {
			$xml .= '	<AccessLicenseNumber>' . $module_params["access_license_number"] . '</AccessLicenseNumber>';
		} else {
			$r->errors .= "UPS module error: AccessLicenseNumber is required.<br>\r\n" ;
		}
		if (isset($module_params["user_id"])) {
			$xml .= '	<UserId>' . $module_params["user_id"] . '</UserId>';
		} else {
			$r->errors .= "UPS module error: UserId is required.<br>\r\n" ;
		}
		if (isset($module_params["user_id"]) && isset($module_params["password"]) && isset($module_params["access_license_number"])) {
			$xml .= '	<Password>' . $module_params["password"] . '</Password>';
		} else {
			$r->errors .= "UPS module error: Password is required.<br>\r\n" ;
		}
		$xml .= '</AccessRequest>';

		$xml .= '<?xml version="1.0"?>';
		$xml .= '<RatingServiceSelectionRequest xml:lang="en-US">';
		$xml .= '	<Request>';
		$xml .= '		<TransactionReference>';
		$xml .= '			<CustomerContext>Bare Bones Rate Request</CustomerContext>';
		$xml .= '			<XpciVersion>1.0</XpciVersion>';
		$xml .= '		</TransactionReference>';
		$xml .= '		<RequestAction>Rate</RequestAction>';
		$xml .= '		<RequestOption>shop</RequestOption>';
		$xml .= '	</Request>';
		$xml .= '<PickupType>';
		if (isset($module_params["PickupType"]) && strlen($module_params["PickupType"])) {
			$xml .= '	<Code>' . $module_params["PickupType"] . '</Code>';
		} else {
			$r->errors .= "UPS module error: PickupType is required.<br>\r\n" ;
		}
		$xml .= '</PickupType>';
		if (isset($module_params["CustomerClassification"]) && strlen($module_params["CustomerClassification"])) {
			$xml .= '<CustomerClassification>' . $module_params["CustomerClassification"] . '</CustomerClassification>';
		}
		$xml .= '<Shipment>';
		$xml .= '	<Shipper>';
		$xml .= '		<Address>';
		if (isset($module_params["ShipperNumber"]) && strlen($module_params["ShipperNumber"])) {
			$xml .= '			<ShipperNumber>' . $module_params["ShipperNumber"] . '</ShipperNumber>';
		}
		if (isset($module_params["ShipperCity"]) && strlen($module_params["ShipperCity"])) {
			$xml .= '			<City>' . $module_params["ShipperCity"] . '</City>';
		}
		if (isset($module_params["ShipperStateProvinceCode"]) && strlen($module_params["ShipperStateProvinceCode"])) {
			$xml .= '			<StateProvinceCode>' . $module_params["ShipperStateProvinceCode"] . '</StateProvinceCode>';
		}
		if (isset($module_params["ShipperPostalCode"]) && strlen($module_params["ShipperPostalCode"])) {
			$xml .= '			<PostalCode>' . $module_params["ShipperPostalCode"] . '</PostalCode>';
		} else {
			$r->errors .= "UPS module error: ShipperPostalCode is required.<br>\r\n" ;
		}
		if (isset($module_params["ShipperCountryCode"]) && strlen($module_params["ShipperCountryCode"])) {
			$xml .= '			<CountryCode>' . $module_params["ShipperCountryCode"] . '</CountryCode>';
		} else {
			$r->errors .= "ShipperCountryCode is required.<br>\r\n" ;
		}
		$xml .= '		</Address>';
		$xml .= '	</Shipper>';
		$xml .= '	<ShipTo>';
		$xml .= '		<Address>';
		if (isset($ShipToCity) && strlen($ShipToCity)) {
			$xml .= '			<City>' . $ShipToCity . '</City>';
		}
		if (isset($state_code) && strlen($state_code)) {
			$xml .= '			<StateProvinceCode>' . $state_code . '</StateProvinceCode>';
		}
		$xml .= '			<PostalCode>' . $postal_code . '</PostalCode>';
		$xml .= '			<CountryCode>' . $country_code . '</CountryCode>';
		if (isset($ShipperResidentialAddressIndicator) && strlen($ShipperResidentialAddressIndicator)) {
			$xml .= '			<ResidentialAddressIndicator>' . $ShipperResidentialAddressIndicator . '</ResidentialAddressIndicator>';
		}
		$xml .= '		</Address>';
		$xml .= '	</ShipTo>';
		$xml .= '	<ShipFrom>';
		$xml .= '		<Address>';
		if (isset($module_params["ShipFromCity"]) && strlen($module_params["ShipFromCity"])) {
			$xml .= '			<City>' . $module_params["ShipFromCity"] . '</City>';
		}
		if (isset($module_params["ShipFromStateProvinceCode"]) && strlen($module_params["ShipFromStateProvinceCode"])) {
			$xml .= '			<StateProvinceCode>' . $module_params["ShipFromStateProvinceCode"] . '</StateProvinceCode>';
		}
		if (isset($module_params["ShipFromPostalCode"]) && strlen($module_params["ShipFromPostalCode"])) {
			$xml .= '			<PostalCode>' . $module_params["ShipFromPostalCode"] . '</PostalCode>';
		} else {
			$r->errors .= "ShipFromPostalCode is required.<br>\r\n" ;
		}
		if (isset($module_params["ShipFromCountryCode"]) && strlen($module_params["ShipFromCountryCode"])) {
			$xml .= '			<CountryCode>' . $module_params["ShipFromCountryCode"] . '</CountryCode>';
		} else {
			$r->errors .= "UPS module error: ShipFromCountryCode is required.<br>\r\n" ;
		}
		$xml .= '		</Address>';
		$xml .= '	</ShipFrom>';
		$xml .= '	<Package>';
		$xml .= '		<PackagingType>';
		if (isset($module_params["PackagingType"]) && strlen($module_params["PackagingType"])) {
		$xml .= '			<Code>' . $module_params["PackagingType"] . '</Code>';
		} else {
			$r->errors .= "UPS module error: PackagingType is required.<br>\r\n" ;
		}
		$xml .= '		</PackagingType>';
		if  (isset($module_params["PackagingType"])
				&& ($module_params["PackagingType"]=='02' || $module_params["PackagingType"]=='21')
			)
		{
			$PackageLength = isset($module_params["PackageLength"]) ? $module_params["PackageLength"] : "";
			$PackageWidth  = isset($module_params["PackageWidth"]) ? $module_params["PackageWidth"] : "";
			$PackageHeight = isset($module_params["PackageHeight"]) ? $module_params["PackageHeight"] : "";
			if (strlen($PackageLength)
				|| strlen($PackageWidth)
				|| strlen($PackageHeight)) {
				$xml .= '		<Dimensions>';
				$xml .= '			<UnitOfMeasurement>';
				if (isset($module_params["PackagingTypeUnitOfMeasurement"]) && strlen($module_params["PackagingTypeUnitOfMeasurement"])) {
					$xml .= '				<Code>' . $module_params["PackagingTypeUnitOfMeasurement"] . '</Code>';
				} else {
					$r->errors .= "UPS module error: PackagingTypeUnitOfMeasurement is required.<br>\r\n" ;
				}
				$xml .= '			</UnitOfMeasurement>';
				if (isset($module_params["PackageLength"]) && strlen($module_params["PackageLength"])) {
					$xml .= '			<Length>' . $module_params["PackageLength"] . '</Length>';
				} else {
					$r->errors .= "UPS module error: PackageLength is required.<br>\r\n" ;
				}
				if (isset($module_params["PackageWidth"]) && strlen($module_params["PackageWidth"])) {
				$xml .= '			<Width>' . $module_params["PackageWidth"] . '</Width>';
				} else {
					$r->errors .= "UPS module error: PackageWidth is required.<br>\r\n" ;
				}
				if (isset($module_params["PackageHeight"]) && strlen($module_params["PackageHeight"])) {
				$xml .= '			<Height>' . $module_params["PackageHeight"] . '</Height>';
				} else {
					$r->errors .= "UPS module error: PackageHeight is required.<br>\r\n" ;
				}
				$xml .= '		</Dimensions>';
			}
		}
		$xml .= '		<PackageWeight>';
		$xml .= '			<UnitOfMeasurement>';
		if (isset($module_params["PackageWeightUnitOfMeasurement"]) && strlen($module_params["PackageWeightUnitOfMeasurement"])) {
			$xml .= '				<Code>' . $module_params["PackageWeightUnitOfMeasurement"] . '</Code>';
		} else {
			$r->errors .= "UPS module error: PackageWeightUnitOfMeasurement is required.<br>\r\n" ;
		}
		$xml .= '			</UnitOfMeasurement>';
		if (!$shipping_weight) {$shipping_weight='0.1';}
		$xml .= '			<Weight>' . $shipping_weight . '</Weight>';
		$xml .= '		</PackageWeight>';
		$xml .= '	</Package>';
		$xml .= '</Shipment>';
		$xml .= '</RatingServiceSelectionRequest>';

		return $xml;

	}

?>